串联所有单词的子串

题目链接:

30. 串联所有单词的子串 - 力扣(LeetCode)

思路:

利用滑动窗口的思路去解决问题

因为题目提到需要满足的情况是串联子串,也就是说,某段字符串必须是同时出现所有的 word 数组,为了减少时间复杂度 ------ 我们利用滑动串口 在右边边界移动 word 单个单词的 位置来进行尽可能的匹配

所以 我们的外循环只需要循环 word 单个单词的长度即可(是在遍历每个位置的可能性)

我们利用滑动窗口,让右边界不停地在 map 里面记录我们所需的数量,直到所记录的单词数量超出,我们进行收缩左边界,直到满足条件,记录下来,其中我们会遇到有不匹配的单词(直接 清除 滑动窗口即可,因为不满足这个条件,也不会满足 串联子串 的定义)

代码:

javascript 复制代码
var findSubstring = function (s, words) {
    if (!s || !words || words.length === 0) return [];
    
    const wordLen = words[0].length;
    const wordCount = words.length;
    const sLen = s.length;
    const result = [];
    
    // 构建目标 Map
    const targetMap = new Map();
    for (const word of words) {
        targetMap.set(word, (targetMap.get(word) || 0) + 1);
    }
    
    // 分桶处理:只需要遍历 wordLen 次
    for (let i = 0; i < wordLen; i++) {
        let left = i;                          // 窗口左边界
        let right = i;                          // 窗口右边界
        let count = 0;                          // 当前窗口中匹配的单词数
        const currentMap = new Map();            // 当前窗口的单词频率
        
        // 滑动窗口
        while (right + wordLen <= sLen) {
            // 1. 右指针移动,加入新单词
            const rightWord = s.substring(right, right + wordLen);
            right += wordLen;
            
            if (targetMap.has(rightWord)) {
                // 更新当前窗口计数
                currentMap.set(rightWord, (currentMap.get(rightWord) || 0) + 1);
                count++;
                
                // 2. 如果某个单词超量,收缩左边界
                while (currentMap.get(rightWord) > targetMap.get(rightWord)) {
                    const leftWord = s.substring(left, left + wordLen);
                    currentMap.set(leftWord, currentMap.get(leftWord) - 1);
                    count--;
                    left += wordLen;
                }
                
                // 3. 如果匹配了所有单词,记录结果
                if (count === wordCount) {
                    result.push(left);
                    
                    // 4. 移动左边界,继续寻找下一个可能的位置
                    const leftWord = s.substring(left, left + wordLen);
                    currentMap.set(leftWord, currentMap.get(leftWord) - 1);
                    count--;
                    left += wordLen;
                }
            } else {
                // 遇到不匹配的单词,重置窗口
                currentMap.clear();
                count = 0;
                left = right;
            }
        }
    }
    
    return result;
};
相关推荐
信奥卷王2 小时前
[GESP202609 六级] 分树规划
算法
夏幻灵2 小时前
LeetCode 21:合并两个有序链表——双指针与哑节点详解
算法·leetcode·链表
徐小黑ACG4 小时前
Golang 基础05 结构体struct
开发语言·算法·golang
Navigator_Z4 小时前
LeetCode //C - 1286. Iterator for Combination
c语言·算法·leetcode
北极有牛5 小时前
cpp学习笔记--常量指针
java·开发语言·算法
GPU实战笔记5 小时前
云端 GPU 训练的账户余额提醒:它能说明什么,不能说明什么?
深度学习·算法·成本管理·gpu云计算·云端训练
浮链序5 小时前
怎么证明"你这个模型是偷我的"——把蒸馏变成取证工具
算法·安全·llm
小O的算法实验室5 小时前
IEEE TMC,面向异构物联网的多目标量子行为拓扑优化算法
算法
liliangcsdn6 小时前
派息率指标的应用探索和分析
大数据·算法